
var index = {
            dontsaveProperties : [],
            dump : function() {
                log(0, actions);
            },
            addNestedObject : function(names, value) {
                var base = this, lastName = arguments.length === 2 ? names.pop() : false;
                for (var i = 0; i < names.length; i++) {
                    base = base[names[i]] = base[names[i]] || {};
                }
                if (lastName)
                    base = base[lastName] = value;
                return base;
            },
            saveState : function() {
                var tempObj = shallowCopy(this);
                var i = this.dontsaveProperties.length;
                while (i--) {
                    delete tempObj[this.dontsaveProperties[i]];
                }
                localStorage.setItem(this.constructor.name, JSON.stringify(tempObj));
            },
            loadState : function() {
                var loaded = JSON.parse(localStorage.getItem(this.constructor.name));
                var merge = function() {
                    var obj = {}, i = 0, il = arguments.length, key;
                    for (; i < il; i++) {
                        for (key in arguments[i]) {
                            if (arguments[i].hasOwnProperty(key)) {
                                obj[key] = arguments[i][key];
                            }
                        }
                    }
                    return obj;
                };
                return merge(this, loaded);
            },
            init : function() {},

};
index.init();
registeredJS.push(index);


var softsure = {
            dontsaveProperties : [],
            dump : function() {
                log(0, actions);
            },
            addNestedObject : function(names, value) {
                var base = this, lastName = arguments.length === 2 ? names.pop() : false;
                for (var i = 0; i < names.length; i++) {
                    base = base[names[i]] = base[names[i]] || {};
                }
                if (lastName)
                    base = base[lastName] = value;
                return base;
            },
            saveState : function() {
                var tempObj = shallowCopy(this);
                var i = this.dontsaveProperties.length;
                while (i--) {
                    delete tempObj[this.dontsaveProperties[i]];
                }
                localStorage.setItem(this.constructor.name, JSON.stringify(tempObj));
            },
            loadState : function() {
                var loaded = JSON.parse(localStorage.getItem(this.constructor.name));
                var merge = function() {
                    var obj = {}, i = 0, il = arguments.length, key;
                    for (; i < il; i++) {
                        for (key in arguments[i]) {
                            if (arguments[i].hasOwnProperty(key)) {
                                obj[key] = arguments[i][key];
                            }
                        }
                    }
                    return obj;
                };
                return merge(this, loaded);
            },
            init : function() {},
init : function() {

    $.soap({
	    url: '%%WSURL_ACCOUNT%%',
		namespaceQualifier: '',
		namespaceURL: 'http://www.softsure.co.za/',

	    soap12: true,
	    appendMethodToURL: false,
		enableLogging: true,
	});

	softsure.dontsaveProperties.push("runningData");
	softsure = softsure.loadState();
},

//USER ACCOUNT VALLS (LOGIN, REGISTER, ETC)
userService : function(command, data, callback) {
	softsure.showLoading();

	$.soap({
		url: '%%WSURL_ACCOUNT%%',
		method: command,
	    data: data,

	    success: function (soapResponse) {
	    	softsure.hideLoading();
			var json = soapResponse.toJSON();
			var resultData = json.Body[command+'Response'][command+'Result'];
			callback(resultData);
	    },

	    beforeSend: function (SOAPEnvelope)  {},
	});
},

//USER SERVICE CALLS (GET POLICY, ETC)
service : function(command, data, callback) {

	softsure.showLoading();
	$.soap({
		url: '%%WSURL_SERVICE%%',
		method: command,
	    data: data,
	    header: { AuthHeader: {LogonID:"%%WSLOGON%%",Password:"%%WSPASSWORD%%"} },

	    success: function (soapResponse) {
	    	softsure.hideLoading();
			var json = soapResponse.toJSON();
			var resultData = json.Body[command+'Response'][command+'Result'];
			callback(resultData);
	    },

	    beforeSend: function (SOAPEnvelope)  {
	    	window.last_env = SOAPEnvelope;
	    },
	});
},

isArray: function(obj) {
	if( Object.prototype.toString.call( obj ) === '[object Array]' ) {
		return true;
	} else {
		return false;
	}
},

loggedIn : function() {
	$$("body").addClass("loggedin");
	app.user.loggedin = true;
	$$($$("#profile-icon")[0].parentElement).attr('target','_profile');

	//Gets InsuredDetail from server. This is saved as softsure.userdetails. Then this is used to set app.user.
	//Note: software.user is set when logging in (login.js)
	softsure.service("getPolicyData",  { UserDetails: softsure.user },  function(res) {

		if (softsure.isArray(res.Policy)) {
			softsure.userdetails = res.Policy[0].InsuredDetail;
			app.user.policyNo = res.Policy[0].PolicyNo;
		}
		else
		{
			softsure.userdetails = res.Policy.InsuredDetail;
			app.user.policyNo = res.Policy.PolicyNo;
		}

		app.user.firstName = softsure.userdetails.FirstName;
		app.user.lastName = softsure.userdetails.Surname;
		app.user.email = softsure.userdetails.EmailAddress;
		app.user.mobile = softsure.userdetails.ContactNo;
		app.user.id = softsure.userdetails.IDNumber;
	});

},

logOut : function() {
	$$("body").removeClass("loggedin");
	app.user.loggedin = false;
	$$($$("#profile-icon")[0].parentElement).attr('target','_login');
},

callbackStartHour: 6,
callbackEndHour: 15,
callbackMessage: "Call me back service is only available during working hours. Please use the Call Now button instead.",

callUsNow: function(number) {
	if (number == undefined) number = "%%DEFAULTCONTACT%%";
        if (app.deviceType == "android") {
            phonedialer.dial(number,function() {
                softsure.alert("Unable to dial the number: "+number);
            });
        } else {
            window.location = "tel:"+number;
        }
},

executeTask : function(task, callback, data, files) {
    window.last_task = {task:task,callback:callback,data:data,files:files};
	var parsedData = {
		PolicyNo: app.user.policyNo,
		TaskVariables: {Variable:[
			{Name: "TASKNAME", Value: task},
		]},
	};
	for(var el in data) {
		parsedData.TaskVariables.Variable.push({Name: el, Value: data[el]});
	}
	if (files) {
		parsedData.Pictures = {
			UploadDoc: [],
		};
		for(var file in files) {
                    console.log(file);
			parsedData.Pictures.UploadDoc.push({FileContents: btoa(files[file]),  FileName: file+".jpg", FileType: 22 });
		}
	}
	softsure.service("executeTask",{TaskDetails:parsedData},callback);
},

alert : function(message) {
	navigator.notification.alert(message);
},

tickerTouch: function() {
	if (softsure.ticker !== undefined) {
		clearInterval(softsure.ticker);
		softsure.ticker = undefined;
		softsure.tickerTarget = undefined;
		softsure.tickerTimer = 0;
		softsure.tickerReturn = false;
		softsure.tickerOldLeft = 0;
	}
	if (this.clientWidth < this.scrollWidth) {
		softsure.tickerTarget = this;
		softsure.ticker = setInterval(function() {
			if (softsure.tickerTimer > 0) softsure.tickerTimer--;
			else if (!softsure.tickerReturn) {
				var newLeft = softsure.tickerTarget.scrollLeft += 1;
				if (softsure.tickerOldLeft == newLeft) {
					softsure.tickerReturn = !softsure.tickerReturn;
					softsure.tickerTimer = 20;
				}
				else softsure.tickerOldLeft = newLeft;
			}
			else {
				var newLeft = softsure.tickerTarget.scrollLeft -= 1;
				if (softsure.tickerOldLeft == newLeft) {
					softsure.tickerReturn = !softsure.tickerReturn;
					softsure.tickerTimer = 20;
				}
				else softsure.tickerOldLeft = newLeft;
			}
		},100);
	}
},

showLoading: function() {
	app.showLoading();
},

hideLoading: function() {
	app.hideLoading();
},
};
softsure.init();
registeredJS.push(softsure);

